#ifdef GUID_SECTION

//fr STDAPI DllGetClassObject-Methode ( struct {long, short, short, 8x uchar array} )
CLSID guid = {0x64009241,0x4306,0x4971,{0xB6,0xE9,0x18,0x4C,0xA1,0x20,0x8F,0x06}};

//fr registry-eintrge
#define PROGID __T("markus.dllmaker") //namespace.Class
#define CLASSID __T("{64009241-4306-4971-B6E9-184CA1208F06}")
#define DLLNAME __T("dllmaker.dll")

BOOL threadIsBusy = FALSE; //relevant evtl bei Thread-Programmierung

#endif


// Methode-ID-Section -> Zuordnen von Methoden oder Properties zu ID's (beispiel)
#ifdef METHODE_ID_SECTION

			int arraySize = 2;  //gesamtanzahl aller Methoden + Properties

			const struct{
				long theID;		//ID der Methode oder Property
				LPOLESTR theName;	//Name der Methode oder Property
			} methodeList []= {
				{2,__T("VerifyBytes")},
				{7,__T("Version")}
			};

#endif

// Invoke Section -> aufruf von Methoden anhand der ID (beispiel)
#ifdef INVOKE_SECTION

//beispiel einer Methode
case 2:			//the Member-ID of methode or Prop
		if ( //verifiziere korrekte Methoden-Signatur:
			(methodeType == DISPATCH_METHOD || methodeType == 0x3) &&  // (weil Aufruf komischerweise statt 0x1 0x3 ist)
			args->cArgs == 1 &&
			args->rgvarg[0].vt == VT_I4   // = Integer
			)
		{
				if (returnVal == NULL) returnVal = new VARIANT;
				returnVal->vt = VT_BSTR; //integer
				//Implementation
				returnVal->bstrVal = testString(args->rgvarg[0].intVal);

				return S_OK;
		}

//beispiel von gettter/setter-Properties
case 7:			//the Member-ID of methode or Prop
		if (//verifiziere korrekte Methoden-Signatur
			methodeType == DISPATCH_PROPERTYGET &&   
			returnVal != NULL
			)
		{
				returnVal->vt = VT_I4; //integer
				//Implementation
				returnVal->intVal = version;

				return S_OK;
		}

		if (//verifiziere korrekte Methoden-Signatur
			methodeType == DISPATCH_PROPERTYPUT &&   
			args->cNamedArgs == 1 &&
			args->rgvarg[0].vt == VT_I4
			)
		{
				//Implementation
				version = args->rgvarg[0].intVal;

				return S_OK;
		}

#endif

// mein Code
#ifdef COSTUME_CODE
//costumers Attributes
int version = 1234;

//costumers Methoden
BSTR testString(int i)
{
		//wchar_t* zahl = new char[4];
		//_itow(i,zahl,10); //2 = binarysystem 10 = dezimal 16 = hex

		wchar_t* text = __T("Alter von nasebge nni");

		LPOLESTR str = new OLECHAR[60];
	    _snwprintf(str,60,__T("%s  %d"),text,i);

		return str;
}
#endif