//unter VS2008:
//1. neues projekt -> visual c++ -> win32 projekt
//2. Assistent unter Anwendungseinstellungen
//											= dll
//											= leeres Projekt
//3. hinzufgen -> vorhandenes Element -> dllmakermain.cpp
//										-> costumized.cpp
//										-> debugging.cpp (fakultativ)
//4. hinzufgen -> neues Element -> def-Datei -> Name "dllmaker.def"
//5. copypaste ->
//				LIBRARY	"dllmaker"
//				EXPORTS
//				DllGetClassObject private   
//				DllRegisterServer private
//				DllUnregisterServer private
//				DllCanUnloadNow private

//folgender Code ist universell und muss nicht gendert werden:

#include <windows.h> //standart
#include <tchar.h>  //zur Stringkonvertierung (__T) -> define __T(x) L ## x
#include <stdio.h>


//struct {long, short, short, 8x uchar array}
IID idispID = {0x00020400,0x0000,0x0000,{0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x46}};//immer dieselbe ID
IID iunownID = {0x00000000,0x0000,0x0000,{0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x46}};//immer dieselbe ID
IID ifactID = {0x00000001,0x0000,0x0000,{0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x46}}; //immer dieselbe id

LPCTSTR concat(LPCTSTR* S) //const wchar-T* -concatenation-Helper
{int len = wcslen(S[0])+wcslen(S[1])+wcslen(S[2])+1; wchar_t* res = new wchar_t[len];_snwprintf(res,len,__T("%s%s%s"),S[0],S[1],S[2]);LPCTSTR r = res; return r;}


#define GUID_SECTION
#include "costumized.cpp"
#undef GUID_SECTION


#define COSTUME_CODE
#include "costumized.cpp"
#undef COSTUME_CODE

//#define DEBUGGING
//#include "debugging.cpp"

//ist jene UniversalKlasse mit der Javascript arbeiten wird
class TheObject : IDispatch{
		ULONG count;
		CLSID objectID;
		CLSID baseID;

	public:
		TheObject(void){}
		~TheObject(void){}
		TheObject(CLSID oid1,CLSID oid2){objectID = oid1; baseID = oid2;count = 0;}
		//IUnknown
		virtual STDMETHODIMP QueryInterface(REFIID riid, void** ppv){
	if(riid == objectID || riid == baseID)
		{
			*ppv =  static_cast<IDispatch*>(this);
			static_cast<IDispatch*>(*ppv) -> AddRef();
		}
		else
		{
			*ppv = 0;
			return E_NOINTERFACE;
		}

		return S_OK;
		}
		virtual STDMETHODIMP_(ULONG) AddRef(void){ return ++count;}
		virtual STDMETHODIMP_(ULONG) Release(void){count--; if (count == 0) delete this; return count;}

		//IDispatch
		virtual STDMETHODIMP GetTypeInfoCount(UINT* i){*i = 0; return S_OK;}
		virtual STDMETHODIMP GetTypeInfo(UINT,LCID,ITypeInfo **){return E_NOTIMPL;}

		virtual STDMETHODIMP GetIDsOfNames(const IID & iidNull ,LPOLESTR * methodes,UINT anzahlMethoden,LCID winstandart ,DISPID * memberIDs){


			#define METHODE_ID_SECTION
			#include "costumized.cpp"
			#undef METHODE_ID_SECTION

			if (arraySize >= anzahlMethoden)
			{
				for (int i = 0; i < anzahlMethoden; i++)
				{
					for (int j = 0; j < arraySize; j++)
					{
						if (wcscmp(methodeList[j].theName,methodes[i])==0)
						{
							memberIDs[i] = methodeList[j].theID;
							break;
						}
					}
				}

				return S_OK;
			}else 
				return E_INVALIDARG;

		}
		virtual STDMETHODIMP Invoke(DISPID memberID,const IID & iidNull,LCID winstandart,WORD methodeType,DISPPARAMS * args,VARIANT * returnVal,EXCEPINFO * null1 ,UINT * null2){


			switch (memberID)
			{

			#define INVOKE_SECTION
			#include "costumized.cpp"
			#undef INVOKE_SECTION
			}
			return E_INVALIDARG;
		
		}
};


//dient dazu die (richtige) Universal-Klasse zu instanzieren
class ObjektManager : public IClassFactory
{
	CLSID factoryID;
	CLSID objectID;
	CLSID baseID;
	ULONG count;
public:
	ObjektManager(void){} //zwingende Implementationen
	~ObjektManager(void){}//ICLASSFactory erbt noch von IUnnown
	ObjektManager(CLSID fid1,CLSID fid2,CLSID fid3){factoryID = fid1; baseID = fid2; objectID = fid3; count = 0;}

	virtual STDMETHODIMP_(ULONG) AddRef(void){return ++count;}

	virtual STDMETHODIMP_(ULONG) Release(void){
		count--; 
		if (count == 0) delete this; 
		return count;
	}
	virtual STDMETHODIMP LockServer(BOOL bLock) {return  E_NOTIMPL; }

	virtual STDMETHODIMP  CreateInstance(IUnknown *pUnkOuter, REFIID riid, LPVOID* ppv)
	{
		if(pUnkOuter !=NULL)
			return CLASS_E_NOAGGREGATION;

		TheObject *hwp = new TheObject(objectID,baseID);
		if(hwp == NULL)	return E_OUTOFMEMORY;

		return hwp->QueryInterface(riid, ppv);
	}

	virtual STDMETHODIMP QueryInterface(REFIID riid, void **ppv){
		if(riid == factoryID || riid == baseID)
		{
			*ppv =  static_cast<IClassFactory*>(this);
			static_cast<IClassFactory*>(*ppv) -> AddRef();
		}
		else
		{
			*ppv = 0;
			return E_NOINTERFACE;
		}

		return S_OK;
	}
};

// Sektion dll-API
// dient dazu, um die DLL in die Registry einzutragen und den Objekt-Manager zu instanzieren


HKEY hkey = NULL;
#define TNUL __T("")
//#define LOCAL_PFAD __T("C:\\Dokumente und Einstellungen\\mrcoffee\\Desktop\\frexperimente\\")
#define EXPL_PFAD __T("C:\\WINDOWS\\Downloaded Program Files\\")

struct{
    BOOL isAkey;		//zum Unterscheiden ob key oder Value
	HKEY hotkey;		//rootkey
	LPCTSTR key[3];		//Registry Key Name (dreiteiliger String)
	LPCTSTR valName[3];	//Registry Value Name
	LPCTSTR val[3];		//Value des Value
} regEntries []= {
	{TRUE,HKEY_CLASSES_ROOT,{PROGID,__T("\\CLSID"),TNUL},{0,0,0},{0,0,0}},
	{FALSE,0,{0,0,0},{TNUL,TNUL,TNUL},{CLASSID,TNUL,TNUL}},

	{TRUE,HKEY_CLASSES_ROOT,{__T("CLSID\\"),CLASSID,__T("\\InprocServer32")},{0,0,0},{0,0,0}},
	{FALSE,0,{0,0,0},{TNUL,TNUL,TNUL},{EXPL_PFAD,DLLNAME,TNUL}},
	{FALSE,0,{0,0,0},{__T("ThreadingModel"),TNUL,TNUL},{__T("Apartment"),TNUL,TNUL}},

	{TRUE,HKEY_LOCAL_MACHINE,{__T("SOFTWARE\\Classes\\"),PROGID,__T("\\CLSID")},{0,0,0},{0,0,0}},
	{FALSE,0,{0,0,0},{TNUL,TNUL,TNUL},{CLASSID,TNUL,TNUL}},

	{TRUE,HKEY_LOCAL_MACHINE,{__T("SOFTWARE\\Classes\\CLSID\\"),CLASSID,__T("\\InprocServer32")},{0,0,0},{0,0,0}},
	{FALSE,0,{0,0,0},{__T("ThreadingModel"),TNUL,TNUL},{__T("Apartment"),TNUL,TNUL}},
	{FALSE,0,{0,0,0},{TNUL,TNUL,TNUL},{EXPL_PFAD,DLLNAME,TNUL}}
};



//luft, wenn in der cmd-Konsole "regsvr32 /u dllmaker.dll" aufgerufen wird
	STDAPI DllUnregisterServer(void)
	{
		
		for (int i = 0; i < RTL_NUMBER_OF(regEntries); i++)
		{
			if (regEntries[i].isAkey == TRUE)
			{
				  //return _Module.UnregisterServer(TRUE);
				RegOpenKeyEx(regEntries[i].hotkey, (LPCWSTR)concat(regEntries[i].key), NULL, DELETE, &hkey);
				RegDeleteKey(regEntries[i].hotkey, (LPCWSTR)concat(regEntries[i].key));
			}
		}
		return 0;
	}

	//luft, wenn in der cmd-Konsole "regsvr32 dllmaker.dll" aufgerufen wird
	STDAPI DllRegisterServer(void)
	{
		int noe = RTL_NUMBER_OF(regEntries); 

		for (int i = 0; i < noe; i++)
		{
			if (regEntries[i].isAkey ==TRUE)
				RegCreateKeyEx(regEntries[i].hotkey, concat(regEntries[i].key), 0, NULL,  
										REG_OPTION_NON_VOLATILE, KEY_SET_VALUE, 
											NULL,   &hkey,  NULL);

			if (regEntries[i].isAkey ==FALSE)
			{
				TCHAR* valBuffer = new TCHAR[200] ;
				_sntprintf_s(valBuffer, 200, 200, concat(regEntries[i].val)); //konvertierung
				RegSetValueEx(hkey, concat(regEntries[i].valName), 0,  REG_SZ, (byte *)valBuffer, 
										(DWORD)(wcslen((const wchar_t*)valBuffer) + 1)*2);
			}

			if (i != (noe-1) && regEntries[i+1].isAkey ==TRUE) RegCloseKey(hkey);
		}

		return 0;
	}

	//instanziert den Objekt-Manager (wird vom System automatisch aufgerufen)
	STDAPI DllGetClassObject (REFCLSID rclsid, REFIID riid, LPVOID* ppv)
	{
		if(rclsid != guid) return CLASS_E_CLASSNOTAVAILABLE;
	
		ObjektManager* pRegClass = new ObjektManager(ifactID,iunownID,idispID);
		pRegClass ->QueryInterface (riid, ppv);

		return S_OK;
	}

	//beim dll-unload (automatischer Aufruf durch System)
	STDAPI DllCanUnloadNow(void)
	{
		return (threadIsBusy==FALSE)? S_OK:S_FALSE;
	}

//ende Sektion dll-API

// Automatismen, wenn die DLL erstmals zur Laufzeit geladen wird (Loadlibrary)
BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		//CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)startMessageBox, NULL, 0, NULL);
		break;
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
	case DLL_PROCESS_DETACH:
		break;
	}
	return TRUE;
}



